
//WebFlow Project, Leader Tom Haupt
//Farhad Mamedbekov, Summer 99

//Demo version.  No Dosplay, Edit Field are disabled.

//Applet for Gateway Log-In Page, implemented with the swing components
//Requires Swing set.  For Netscape, it is envisage 
// to have the swing on the client machine
//Envokes the servlet with the proper parameters



import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;

import javax.swing.*;


public class DemoPortal extends JApplet 
                         implements ActionListener {

  //////////////  Variable Declarations ///////////////////////////
  
  //Parameters passed by HTML
  protected String DISPLAY;
  protected String HOST;
  protected String jhost;
  protected String jport;
  protected String jroot;
  protected String RelMasterIOR;
  protected String RelIorDir;
  protected String UsrConfDir;
  protected String servletURL;

  //Timer related parameters
  protected int ActionCount = 0;
  protected int attempts = 100;
  public final static int ONE_SECOND = 1000; 
  public final static int TIMER_LENGTH=100;
   
  //inerface elements
  protected JProgressBar progressBar;
  protected String buttonTitle [] = {"Start Session" , "Stop Session"};
  protected JButton SubmitButton = new JButton (buttonTitle[0]);
  protected JButton ResetButton = new JButton (buttonTitle[1]);
  protected JTextField  editParam[];
  protected JPasswordField  editPsw;
  protected String titleParam[] = { "Display", "Host", "UserID", "Password"};

  //two helper classes
  private Timer timer;
  private LongTask2 task = new LongTask2(1,this);

  /////////// End of Variable Declarations ////////////////////////

  public String sameOrBlank(String s)
  {
     if (s==null)
       return "";
     return s;
  }

  //draws the user interface and sets up the timer
  public void init() { 

    //Get the HTML - passed parameters
    DISPLAY =  sameOrBlank(getParameter("DISPLAY"));
    HOST =  sameOrBlank(getParameter("HOST"));
    jhost =  sameOrBlank(getParameter("jhost"));
    jport =  sameOrBlank(getParameter("jport"));
    jroot =  sameOrBlank(getParameter("jroot"));
    RelMasterIOR =  sameOrBlank(getParameter("RelMasterIOR"));
    RelIorDir =  sameOrBlank(getParameter("RelIorDir"));
    servletURL =  sameOrBlank(getParameter("servletURL")); 
    UsrConfDir =  sameOrBlank(getParameter("UsrConfDir"));

    getContentPane().setLayout( new BorderLayout() );
    //new GridLayout(6,1)); 

    //Add ProgressBar
    progressBar = new JProgressBar(0, TIMER_LENGTH);
    progressBar.setValue(0);
    progressBar.setStringPainted(true);
    getContentPane().add(progressBar, BorderLayout.NORTH);
   
    //Add Edit Fields with Titles
    JPanel editPanel = new JPanel();
    editPanel.setLayout( new GridLayout(titleParam.length, 1));
    editParam = new JTextField [titleParam.length-1];
    editParam[0] = new JTextField (DISPLAY);  
    editPanel.add( editParam[0]);  
    editParam[1] = new JTextField (HOST);
    editPanel.add(editParam[1]);
    editParam[2] = new JTextField ("webflow");
    editPanel.add(editParam[2]); 
    editPsw = new  JPasswordField ("");
    editPanel.add(editPsw); 
   
    //DEmo version downcasting
    for (int i=0; i<3; i++)
      editParam[i].setEditable(false);
    editPsw.setEditable(false);
    ////////////////////////////////////////


    JPanel labelPanel = new JPanel();
    labelPanel.setLayout( new GridLayout(titleParam.length, 1));
    for (int i = 0 ; i<titleParam.length; i++)
    {
       labelPanel.add(new JLabel(titleParam[i], 10)  );
    }

    JPanel centerPanel =  new JPanel();
    centerPanel.setLayout( new BorderLayout());
    centerPanel.add(labelPanel, BorderLayout.WEST);
    centerPanel.add(editPanel, BorderLayout.CENTER); 
    getContentPane().add(centerPanel, BorderLayout.CENTER);
     
 
    //Add  buttons
    JPanel tmpPanel2 = new JPanel();
    tmpPanel2.setLayout( new GridLayout(1,2));
    tmpPanel2.add(SubmitButton);
    tmpPanel2.add(ResetButton);
    SubmitButton.addActionListener(this);
    getContentPane().add(tmpPanel2,BorderLayout.SOUTH  );

    //set up the timer
    timer = new Timer(ONE_SECOND, new ActionListener() {
            public void actionPerformed(ActionEvent evt) 
            {
                task.go();            
                if (task.done())
                {
                    Toolkit.getDefaultToolkit().beep();
                    timer.stop();
                    setScreen( 0);
                    setControls(true);    //controls was disable by actionPerformed 
                }
                else 
		{
                   int IProg=TIMER_LENGTH * task.getCurrent() / task.getLengthOfTask();
                   setScreen(IProg );
		}  //else
            }
    });  //end of timer

  }   //init
     
 

  //checks which cutton is pressed and sets the corresponding task parameters
  //runs the timer to execute the task
  public void actionPerformed(ActionEvent e) 
  {
     String toPass = servletURL +
         "?DISPLAY="+ editParam[0].getText() +  //DISPLAY+
         "&HOST=" + editParam[1].getText() +  //HOST +
         "&UserContext=" + editParam[2].getText() +
         "&pw=" + editPsw.getText() +
         "&jhost=" + jhost  +
         "&jport=" + jport  +
         "&jroot=" + jroot   +
         "&RelMasterIOR=" + RelMasterIOR   +
         "&RelIorDir=" + RelIorDir   +
         "&UsrConfDir=" + UsrConfDir;
	
     System.err.println("\n"+ toPass + "\n");
     task.setTask(toPass, attempts);
     setControls(false);
     timer.start();
  }    //actionPerformed

  public void setScreen( int STBarLen)
  {
    //set the progressbar value
    progressBar.setValue(STBarLen);      
  }

  //Enables or disables user contrlos so that the user does not run multiple threads
  public void setControls(boolean bstate)
  {  
      SubmitButton.setEnabled(bstate);
  }     
}


//Implements communication with servlet
//Does not know anything about interface

class LongTask2
{
  static int counter;      //times attempted to run the task
  static int tasklength;   //maximum numer to run the tast
  static String lastMSG;   //last mesage from the servlet
  static String SURL;      //URL to be executed the first time
  static String CURL;      //URL to be executed from the second time on
  static String TermMSG;   //mesage from the servlet that stops execution
  static boolean done;     //done?
  private JApplet applet;

  //constructor
  public LongTask2(int _tasklength, JApplet applet)
  {
    tasklength=_tasklength;
    this.applet=applet;
    counter=0;
    tasklength=10; //_counter;
    done=true;
  }

  //return internal variables
  public boolean done() { return done;}
  public int getCurrent() {return counter;}
  public int getLengthOfTask() { return tasklength;}
  public String getMessage() { return lastMSG;}

  //sets up the task parameters before each execution
  public void setTask(String _SURL, int _tasklength)
  {
     SURL=_SURL;
     tasklength=_tasklength;
     done=false;
     counter=0;
     triggerServlet(SURL); 
  }

  //contains actions implemented at each call of the task
  //reads URL, stops if the message is right or enoght attempts
  public void go()
  {
      counter++;
      if (counter==tasklength)
           done=true;
  }

  //Passes the URL
  public void triggerServlet (String sURL)
  {

  AppletContext ac = applet.getAppletContext();
  
    try {
      java.net.URL url = new java.net.URL(sURL);
      ac.showDocument(url);
    }
      catch(Exception e) {
        System.err.println("Servlet when calling error "+e);
      }
    

      /*
       InputStream istream;

      try {
	  istream = url.openStream();
          istream.close();
      }
      catch(Exception e) {
        System.err.println("Error while reading from: " + sURL);
      }
    }  //outer try
    catch(Exception e) {
      System.err.println("Can't open URL: " + sURL);
    }
    */

  }  //function triggerServlet 

}  //classs LongTask


